(*****************************************************************************
*                                                                           *
*  Copyright 1996 bei Stefan Graf (CompuServe: 100736.2464)                 *
*                                                                           *
*  !!!!!!!!!!!!!!!!!!!!!! Nicht registrierte Version   !!!!!!!!!!!!!!!!!!!! *                                              *
*                                                                           *
*****************************************************************************)

unit Capibase;

{$C FIXED PERMANENT}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

const
  WM_CAPINOTIFY  = 60000;  {Diese Message wird bei jeder anstehenden CAPI-Meldung }
                           {an den Window-Messagehaendler geschickt.              }
  CAPI_MESSAGE   = 0;      {Dies ist der lParam der Meldung ans Windows.          }


{Konstanten fr das Anlegen des Applications-Buffers}

  DMessages    = 70;
  DB3Connects  = 4;
  DB3Blocks    = 4;
  DB3BlockSize = 2048;

{Die Konstanten fr alle mglichen CAPI-Messages }
  REQ                = $00;
  CONF               = $01;
  IND                = $02;
  RESP               = $03;

  RESET_B3           = $01;
  CONNECT            = $02;
  CONNECT_ACTIVE     = $03;
  DISCONNECT         = $04;
  LISTEN             = $05;
  GET_PARAMS         = $06;
  INFO               = $07;
  DATA               = $08;
  CONNECT_INFO       = $09;
  SELECT_B2_PROTOCOL = $40;
  SELECT_B3_PROTOCOL = $80;
  LISTEN_B3          = $81;
  CONNECT_B3         = $82;
  CONNECT_B3_ACTIVE  = $83;
  DISCONNECT_B3      = $84;
  GET_B3_PARAMS      = $85;
  DATA_B3            = $86;
  HANDSET            = $87;
  MANUFACTURER       = $FF;


{Konstanten fr die Protokolldefinition auf der B2-Ebene}

  ProtokolB2_X75       = $01; {Fr Datenbertragung}
  ProtokolB2_TRANSHDLC = $02;
  ProtokolB2_BITTRANS  = $03;
  ProtokolB2_SNA_SDLC  = $04;
  ProtokolB2_BTX_X75   = $05;
  ProtokolB2_FAX       = $06;
  ProtokolB2_LAPD      = $07;
  ProtokolB2_V110TRANS = $08;
  ProtokolB2_V110SDLC  = $09;
  ProtokolB2_V110X75   = $0a;


{Konstanten fr die Protokolldefinition auf der B3-Ebene}

  ProtokolB3_T70NL       = $01;
  ProtokolB3_ISO8208     = $02;
  ProtokolB3_T90         = $03;
  ProtokolB3_TRANSPARENT = $04; {Fr Datenbertragung}
  ProtokolB3_T30         = $05; {Fr FAX G3 bertragung}


{Konstanten fr die Festlegen des ISDN-Services}

  Service_VIDEO_TELEPHONY   = $0001;
  Service_TELEPHONY         = $0002;
  Service_AB_SERVICE        = $0004;
  Service_X21               = $0008;
  Service_FAX4              = $0010;
  Service_BTX               = $0020;
  Service_DATA_64K          = $0080; {Fr Datenbertragung}
  Service_X25               = $0100;
  Service_TTX64             = $0200;
  Service_MIXED_MODE        = $0400;
  Service_TEMEX             = $1000;
  Service_GRAPHIC_TELEPHONY = $4000;
  Service_NEW_BTX           = $8000;


{Konstanten fr die Festlegen des ISDN-Services Additions}

  ServiceAdd_Analog = $02;
  ServiceAdd_FAX3   = $03;


{Die Konstanten fr das Empfangen von W-Elementen in der Info-Message}

  InfoGebuehren  = $01;
  InfoDatumZeit  = $02;
  InfoDisplay    = $04;
  InfoUserToUser = $08;
  InfoCause      = $10;
  InfoStatus     = $20;

  InfoAlle       = $3F;

{Type zum Umsetzen des Rckgabewertes von GlobalDosAlloc}

{Alle Datentypen fr die CAPI-Messages}

type
  CapiParameterType = String [180];

  PLCIType = record PLCI : Word; end;
  NCCIType = record NCCI : Word; end;

  PLCIInfoType = record
    PLCI : Word;
    Info :Word;
  end;

  ProtokolB2Type = record
    Size : Byte;
    DataLength : Word;
    LinkAdrA : Byte;
    LinkAdrB : Byte;
    ModuloMode : Byte;
    WindowSize : Byte;
    case Word of
      0 : (XID : CapiParameterType;);
      1 : (V110_UserRate : Byte;
           V110_XID : CapiParameterType;);
  end;

  ProtokolB3Type = record
    Size : Byte;
    LIC : Word;
    HIC : Word;
    LTC : Word;
    HTC : Word;
    LOC : Word;
    HOC : Word;
    ModuloMode : Byte;
  end;

  ConnectConfType          = PLCIInfoType;
  ActiveConnectConfType    = PLCIInfoType;
  DisconnectConfType       = PLCIInfoType;
  InfoConfType             = PLCIInfoType;
  ListenB3ConfType         = PLCIInfoType;
  SelectB2ProtokolConfType = PLCIInfoType;
  SelectB3ProtokolConfType = PLCIInfoType;
  DataConfType             = PLCIInfoType;

  ListenConfType = record
    Controller : Byte;
    Info : Word;
  end;

  B3ConnectConfType = record
    PLCI : Word;
    NCCI : Word;
    Info : WOrd;
  end;

  ActiveB3ConnectConfType = NCCIType;

  DisconnectB3ConfType = record
    NCCI : Word;
    Info : Word;
  end;

  DataB3ConfType = record
    NCCI : Word;
    BlockNr : Byte;
    Info : Word;
  end;

  ParameterConfType = record
    PLCI : Word;
    Controller : Byte;
    BKanal : Byte;
    Info : Word;
    AnzahlB3 : Byte;
    Service : Byte;
    ServiceAdd : Byte;
    EAZ : Byte;
    CallerAdr : CapiParameterType;
  end;

  ParameterB3ConfType = record
    NCCI : Word;
    PLCI : Word;
    Info : Word;
  end;


  ConnectIndType = record
    PLCI : Word;
    Controller : Byte;
    ReqService : Byte;
    ReqServiceAdd : Byte;
    ReqEAZ : Byte;
    CallerAdr : CapiParameterType;
  end;

  ActiveConnectIndType = record
    PLCI : Word; 
    ConnectedAdr : CapiParameterType;
  end;

  DisconnectIndType = record
    PLCI : Word; 
    Grund : Word;
  end;

  InfoIndType = record
    PLCI : Word; 
    InfoNr : Word;
    Info : CapiParameterType;
  end;

  ConnectB3IndType = record
    NCCI : Word;
    PLCI : Word;
    NCPI : CapiParameterType;
  end;

  ActiveB3ConnectIndType = record
    NCCI : Word;
    NCPI : CapiParameterType;
  end;

  DisconnectB3IndType = record
    NCCI : Word;
    Grund : Word;
    NCPI : CapiParameterType;
  end;

  DataIndType = record
    PLCI : Word;
    UserDaten : CapiParameterType;
  end;

  DataB3IndType = record
    NCCI : Word;
    DataSize : Word;
    DataPtr : Pointer;
    BlockNr : Byte;
    Flags : Byte;
  end;

  IndicationDatenType = record
    case Word of
      CONF :
        (case Word of
           CONNECT            : (ConnectConf : ConnectConfType;);
           CONNECT_ACTIVE     : (ActiveConnectConf : ActiveConnectConfType;);
           DISCONNECT         : (DisconnectConf : DisconnectConfType;);
           DISCONNECT_B3      : (DisconnectB3Conf : DisconnectB3ConfType;);
           INFO               : (InfoConf : InfoConfType;);
           LISTEN             : (ListenConf : ListenConfType;);
           LISTEN_B3          : (ListenB3Conf : ListenB3ConfType;);
           SELECT_B2_PROTOCOL : (SelectB2ProtokolConf : SelectB2ProtokolConfType;);
           SELECT_B3_PROTOCOL : (SelectB3ProtokolConf : SelectB2ProtokolConfType;);
           CONNECT_B3         : (B3ConnectConf : B3ConnectConfType;);
           CONNECT_B3_ACTIVE  : (ActiveB3ConnectConf : ActiveB3ConnectConfType;);
           DATA               : (DataConf : DataConfType;);
           DATA_B3            : (DataB3Conf : DataB3ConfType;);
           GET_PARAMS         : (ParameterConf : ParameterConfType;);
           GET_B3_PARAMS      : (ParameterB3Conf : ParameterB3ConfType;);
        );

      IND :
        (case Word of
           CONNECT            : (ConnectInd : ConnectIndType;);
           CONNECT_ACTIVE     : (ActiveConnectInd : ActiveConnectIndType;);
           DISCONNECT         : (DisconnectInd : DisconnectIndType;);
           INFO               : (InfoInd : InfoIndType;);
           CONNECT_B3         : (ConnectB3Ind : ConnectB3IndType;);
           CONNECT_B3_ACTIVE  : (ActiveB3ConnectInd : ActiveB3ConnectIndType;);
           DISCONNECT_B3      : (DisconnectB3Ind : DisconnectB3IndType;);
           DATA               : (DataInd : DataIndType;);
           DATA_B3            : (DataB3Ind : DataB3IndType;);
         );
  end;


  InfoRespType          = PLCIType;
  ActiveConnectRespType = PLCIType;
  DisconnectRespType    = PLCIType;
  DataRespType          = PLCIType;

  ConnectRespType = record
    PLCI : Word;
    Reject : Byte;
  end;

  ConnectB3RespType = record
    NCCI : Word;
    Reject : Byte;
    NCPI : CapiParameterType;
  end;

  ActiveB3ConnectRespType = NCCIType;
  DisconnectB3RespType    = NCCIType;
  
  DataB3RespType = record
    NCCI : Word;
    BlockNr : Byte;
  end;


  RespondDatenType = record
    case Word of
      CONNECT            : (ConnectResp : ConnectRespType;);
      CONNECT_ACTIVE     : (ActiveConnectResp : ActiveConnectRespType;);
      DISCONNECT         : (DisconnectResp : DisconnectRespType;);
      INFO               : (InfoResp : InfoRespType;);
      CONNECT_B3         : (ConnectB3Resp : ConnectB3RespType;);
      CONNECT_B3_ACTIVE  : (ActiveB3ConnectResp : ActiveB3ConnectRespType;);
      DISCONNECT_B3      : (DisconnectB3Resp : DisconnectB3RespType;);
      DATA               : (DataResp : DataRespType;);
      DATA_B3            : (DataB3Resp : DataB3RespType;);
  end;


  ListenReqType = record
    Controller : Byte;
    InfoMask   : LongInt;
    EAZMask    : Word;
    SIMask     : Word;
  end;

  ConnectReqType = record
    Controller : Byte;
    BKanal : Byte;
    InfoMask : LongInt;
    Service : Byte;
    ServiceAdd : Byte;
    EAZ : Char;
    Rufnummer : CapiParameterType;
  end;

  ConnectInfoReqType = record
    PLCI : Word;
    Zusatznummern : CapiParameterType;
  end;

  SelectB2ProtocolReqType = record
    PLCI : Word;
    Protokoll : Byte;
    DLPD : ProtokolB2Type;
  end;

  SelectB3ProtocolReqType = record
    PLCI : Word;
    Protokoll : Byte;
    NCPD : ProtokolB3Type;
  end;

  ConnectB3ReqType = record
    PLCI : Word;
    NCPI : CapiParameterType;
  end;


  DataReqType = record
    PLCI : Word;
    UserDaten : CapiParameterType;
  end;

  DataB3ReqType = record
    NCCI : Word;
    Size : Word;
    Daten : Pointer;
    BlockNr : Byte;
    Flags : Word;
  end;

  ListenB3ReqType = record
    PLCI : Word;
  end;

  DisconnectB3ReqType = record
    NCCI : Word;
    NCPI : CapiParameterType;
  end;

  DisconnectReqType = record
    PLCI : Word;
    Grund : Byte;
  end;

  InfoReqType = record
    PLCI : Word;
    InfoMask : LongInt;
  end;

  ParameterReqType   = PLCIType;
  ParameterB3ReqType = NCCIType;
  ResetB3ReqType     = NCCIType;

  RequestDatenType = record
    case Word Of
      CONNECT            : (ConnectReq : ConnectReqType;);
      CONNECT_INFO       : (ConnectInfoReq : ConnectInfoReqType;);
      CONNECT_B3         : (ConnectB3Req : ConnectB3ReqType;);
      DISCONNECT         : (DisconnectReq : DisconnectReqType;);
      DISCONNECT_B3      : (DisconnectB3Req : DisconnectB3ReqType;);
      LISTEN             : (ListenReq : ListenReqType;);
      LISTEN_B3          : (ListenB3Req : ListenB3ReqType;);
      GET_PARAMS         : (ParameterReq : ParameterReqType;);
      INFO               : (InfoReq : InfoReqType;);
      DATA               : (DataReq : DataReqType;);
      SELECT_B2_PROTOCOL : (SelectB2ProtocolReq : SelectB2ProtocolReqType;);
      SELECT_B3_PROTOCOL : (SelectB3ProtocolReq : SelectB3ProtocolReqType;);
      GET_B3_PARAMS      : (ParameterB3Req : ParameterB3ReqType;);
      DATA_B3            : (DataB3Req : DataB3ReqType;);
      RESET_B3           : (ResetB3Req : ResetB3ReqType;);
  end;

  BufferType = array [1..8196] of byte;
  DatenBufferType = Record
    BlockNr     : Word;
    BlockSize   : Word;
    ByteCount   : Word;
    ByteIndex   : Word;
    ReadyToSend : Boolean;
    Buffer      : ^BufferType;
  end;

  TCapiMessageEvent = procedure (Sender:TObject;
                                 const CommandID, SubCommand, MsgID : Word;
                                 var Daten : IndicationDatenType) of object;

  TCapiDumpEvent    = procedure (Sender:TObject;
                                 const CommandID, SubCommand : Word;
                                 var Daten : IndicationDatenType) of object;

  TCapiErrorEvent   = procedure (Sender:TObject;
                                 const CommandID, SubCommand, ErrorNumber : Word) of object;

  TAddressMode = (Real,Protect);

  TCapiBase = class(TComponent)
    private
     { Private-Deklarationen }
     ApplicationBuffer : Pointer;

     IsLoaded : Boolean;

     CapiError : Integer;
     OutMsgID : Word;

     ApplicationRegistered : Boolean;
     ApplicationID : Word;
     ApplicationBufferSize : Word;

     WindowHandle : hWnd;

     FDMessages,
     FB3Connects,
     FB3Blocks,
     FB3BlockSize : Word;

     FMessageReceived : TCapiMessageEvent;
     FMessageDump     : TCapiDumpEvent;
     FError           : TCapiErrorEvent;

     procedure CapiWinProc (var Msg:TMessage);

     procedure SetAnzahlMessages   (const Anzahl   : Word);
     procedure SetAnzahlConnects   (const Anzahl   : Word);
     procedure SetAnzahlB3Blocks   (const Anzahl   : Word);
     procedure SetB3BlockSize      (const Size     : Word);

     procedure RegisterApplication;
     procedure ReleaseApplication;
  protected
    { Protected-Deklarationen }
    procedure Loaded; override;

    procedure DoMessage   (const CommandID, SubCommand, MsgID : Word;
                             var Daten : IndicationDatenType); virtual;
    procedure SetError (const CommandID, SubCommand, ErrorNr : Word);
  public
    { Public-Deklarationen }
    constructor Create (AOwner:TComponent); override;
    destructor  Destroy; override;

    procedure DoCapiMessage;

    function GetCommandStr (const Command, SubCommand : Word):string;
    function GetErrorStr   (const Error : Word):string;

    function GetVersion      : String;
    function GetSerialNumber : String;
    function GetHersteller   : String;
    function GetAddressMode  : TAddressMode;

    function SendRequestMessage (CommandID : Word; var Daten) : Boolean;
    function SendResponsMessage (CommandID, MsgID : Word; var Daten) : Boolean;
    function GetMessage (var CommandID, SubCommand, MsgID : Word; var Daten : IndicationDatenType) : Word;

  published
    { Published-Deklarationen }
    property Messages    : Word        read FDMessages   write SetAnzahlMessages default DMessages;
    property Connects    : Word        read FB3Connects  write SetAnzahlConnects default DB3Connects;
    property B3Blocks    : Word        read FB3Blocks    write SetAnzahlB3Blocks default DB3Blocks;
    property B3BlockSize : Word        read FB3BlockSize write SetB3BlockSize    default DB3BlockSize;

    {Ereignis-Propertys}

    property MessageReceived : TCapiMessageEvent     read FMessageReceived write FMessageReceived;
    property MessageDump     : TCapiDumpEvent        read FMessageDump     write FMessageDump;
    property OnError         : TCapiErrorEvent       read FError           write FError;
  end;

procedure Register;

implementation

type
  CapiHeader = record
     Size       : Word;
     AppID      : Word;
     Command    : Byte;
     SubCommand : Byte;
     MsgNumber  : Word;
  end;

  CapiMessage = record
    Header : CapiHeader;
    Daten  : array [0..180] of byte;
  end;

var
  CapiLibHandle : THandle;
  ClassLoaded   : Boolean;

constructor TCapiBase.Create (AOwner : TComponent);
begin
  if (ClassLoaded) then begin
    if (MessageDLG ('Es kann nur eine Instanz von TCapi erzeugt werden',mtError, [mbOk,mbAbort], 0) = mrAbort) then
      Abort;
  end;

  inherited Create(AOwner);

  ClassLoaded   := True;

  FDMessages   := DMessages;
  FB3Connects  := DB3Connects;
  FB3Blocks    := DB3Blocks;
  FB3BlockSize := DB3BlockSize;

  WindowHandle := AllocateHWnd (CapiWinProc);

  IsLoaded := false;

  ApplicationBuffer     := nil;
  ApplicationBufferSize := 0;
  ApplicationRegistered := false;
end;

destructor TCapiBase.Destroy;
begin
  DeallocatehWnd (WindowHandle);

  ReleaseApplication;

  IsLoaded := false;

  if (CapiLibHandle <> 0) then
    FreeLibrary (CapiLibHandle);

  inherited Destroy;
end;


{Definieren der Funktion aus der CAPI.DLL}
type
  F_API_REGISTER = Function (pcSpeicherBlock  : Pointer;
                             nAnzahlMessages,
                             nAnzahlEbene3,
                             nAnzahlB3Data,
                             nMaxLenB3Data    : Word) : Word;

  F_API_RELEASE     = Function (nApplikationsNummer : Word) : Word;
  F_API_PUT_MESSAGE = Function (nApplikationsNummer : Word; pcMessage : Pointer) : Word;
  F_API_GET_MESSAGE = Function (nApplikationsNummer : Word; Var pcMessage) : Word;
  F_API_SET_SIGNAL  = Function (nApplikationsNummer : Word; Signal : Pointer) : Word;

  F_API_GET_MANUFACTURER   = Function (szBuffer : PChar) : Word;
  F_API_GET_VERSION        = Function (szBuffer : PChar) : Word;
  F_API_GET_SERIAL_NUMBER  = Function (szBuffer : PChar) : Word;
  F_API_GET_ADDRESSMODE    = Function : Word;
  F_API_INSTALLED          = Function : Word;

var
  API_REGISTER    : F_API_REGISTER;
  API_RELEASE     : F_API_RELEASE;
  API_PUT_MESSAGE : F_API_PUT_MESSAGE;
  API_GET_MESSAGE : F_API_GET_MESSAGE;
  API_SET_SIGNAL  : F_API_SET_SIGNAL;

  API_GET_MANUFACTURER  : F_API_GET_MANUFACTURER;
  API_GET_VERSION       : F_API_GET_VERSION;
  API_GET_SERIAL_NUMBER : F_API_GET_SERIAL_NUMBER;
  API_GET_ADDRESSMODE   : F_API_GET_ADDRESSMODE;
  API_INSTALLED         : F_API_INSTALLED;

{Hier wird die Message an den Window-Messagehandler geschickt}
{$R-,S-}
var
  MainWindow : hWnd;

procedure PostMsg;
begin
  PostMessage (MainWindow,WM_CAPINOTIFY,0,CAPI_MESSAGE);
end;

{Die Interrupt-Routine die das CAPI bei jeder anstehenden Nachricht aufruft}
procedure CapiInterrupt; assembler;
asm
  push ds
  push ax

  mov ax,SEG @DATA
  mov ds,ax

  call PostMsg;

  pop ax
  pop ds

  retf;
end;


procedure TCapiBase.Loaded;
begin
  inherited Loaded;

  CapiLibHandle := LoadLibrary ('CAPI.DLL');

  if (CapiLibHandle < 32) then
    SetError (0,0,1)
  else begin
    @API_REGISTER    := GetProcAddress (CapiLibHandle,'API_REGISTER');
    @API_RELEASE     := GetProcAddress (CapiLibHandle,'API_RELEASE');
    @API_PUT_MESSAGE := GetProcAddress (CapiLibHandle,'API_PUT_MESSAGE');
    @API_GET_MESSAGE := GetProcAddress (CapiLibHandle,'API_GET_MESSAGE');
    @API_SET_SIGNAL  := GetProcAddress (CapiLibHandle,'API_SET_SIGNAL');

    @API_GET_MANUFACTURER  := GetProcAddress (CapiLibHandle,'API_GET_MANUFACTURER');
    @API_GET_VERSION       := GetProcAddress (CapiLibHandle,'API_GET_VERSION');
    @API_GET_SERIAL_NUMBER := GetProcAddress (CapiLibHandle,'API_GET_SERIAL_NUMBER');
    @API_GET_ADDRESSMODE   := GetProcAddress (CapiLibHandle,'API_GET_ADDRESSMODE');
    @API_INSTALLED         := GetProcAddress (CapiLibHandle,'API_INSTALLED');

    if (API_INSTALLED = 0) then
      SetError (0,0,2)
    else if (API_GET_ADDRESSMODE = 0) then
      SetError (0,0,3)
    else
      RegisterApplication;
  end;

  IsLoaded := true;
end;

{Der berladene Messagehandler fr das Verarbeiten der CAPI-Message}
procedure TCapiBase.CapiWinProc (var Msg:TMessage);

begin
  with Msg do begin
    if (Msg <> WM_CAPINOTIFY) then
      Result:=DefWindowProc (WindowHandle,Msg,wParam,lParam)
    else begin
      case lParamLo of
        CAPI_MESSAGE : DoCapiMessage;
      end;
    end;
  end;
end;

procedure TCapiBase.DoCapiMessage;
var
  cmd,
  msgid,
  subcmd : Word;
  daten  : IndicationDatenType;

begin
  while (GetMessage (cmd,subcmd,msgid,daten) = 0) do begin
    if Assigned (FMessageDump) then
      FMessageDump (Self,cmd,subcmd,daten);

    if Assigned (FMessageReceived) then
      FMessageReceived (Self,cmd,subcmd,msgid,daten)
    else DoMessage (cmd,subcmd,msgid,daten);
  end;
end;

procedure TCapiBase.DoMessage (const CommandID, SubCommand, MsgID : Word;
                               var Daten : IndicationDatenType);
begin
end;

procedure TCapiBase.SetAnzahlMessages   (const Anzahl : Word);
begin
  if (FDMessages <> Anzahl) then begin
    FDMessages := Anzahl;
    if IsLoaded then RegisterApplication;
  end;
end;

procedure TCapiBase.SetAnzahlConnects   (const Anzahl : Word);
begin
  if (FB3Connects <> Anzahl) then begin
    FB3Connects := Anzahl;
    if IsLoaded then RegisterApplication;
  end;
end;

procedure TCapiBase.SetAnzahlB3Blocks (const Anzahl : Word);
begin
  if (FB3Blocks <> Anzahl) then begin
    FB3Blocks := Anzahl;
    if IsLoaded then RegisterApplication;
  end;
end;

procedure TCapiBase.SetB3BlockSize    (const Size : Word);
begin
  if (FB3BlockSize <> Size) then begin
    FB3BlockSize := Size;
    if IsLoaded then RegisterApplication;
  end;
end;

procedure TCapiBase.SetError (const CommandID, SubCommand, ErrorNr : Word);
begin
  if Assigned (FError) then
    FError (Self,CommandID, SubCommand, ErrorNr);
end;

procedure TCapiBase.RegisterApplication;
begin
  ReleaseApplication;

  ApplicationBufferSize := 180 * FDMessages + (FB3Connects * FB3Blocks * FB3BlockSize);

  GetMem (ApplicationBuffer,ApplicationBufferSize);
  ApplicationID := API_REGISTER (ApplicationBuffer, FDMessages, FB3Connects, FB3Blocks, FB3BlockSize);

  if (ApplicationID = 0) then
    CapiError := -1
  else begin
    OutMsgID := 0;
    CapiError := 0;

    MainWindow := WindowHandle;

    API_SET_SIGNAL (ApplicationID,@CapiInterrupt);

    ApplicationRegistered := true;
  end;
end;


procedure TCapiBase.ReleaseApplication;

begin
  if (ApplicationRegistered) then begin
    API_RELEASE (ApplicationID);

    if (ApplicationBuffer <> nil) then
       FreeMem (ApplicationBuffer,ApplicationBufferSize);

    ApplicationBuffer := nil;
  end;

  ApplicationRegistered := false;
end;

function TCapiBase.SendRequestMessage (CommandID : Word; var Daten) : Boolean;
var
  msg     : CapiMessage;
  err,
  msgsize : Word;
begin
  if not (ApplicationRegistered) then
    err := 4
  else begin
    SendRequestMessage := true;

    msgsize := 0;
    case CommandID of
      LISTEN             : msgsize := 9;
      LISTEN_B3          : msgsize := 2;
      CONNECT            : msgsize := 10 + Length (ConnectReqType (Daten).Rufnummer);
      CONNECT_INFO       : msgsize := 3 + Length (ConnectInfoReqType (Daten).ZusatzNummern);
      CONNECT_B3         : msgsize := 3 + Length (ConnectB3ReqType (Daten).NCPI);
      DISCONNECT         : msgsize := 3;
      DISCONNECT_B3      : msgsize := 3 + Length (DisconnectB3ReqType (Daten).NCPI);
      INFO               : msgsize := 6;
      DATA               : msgsize := 3 + Length (DataReqType (Daten).UserDaten);
      DATA_B3            : msgsize := 11;
      SELECT_B2_PROTOCOL : msgsize := 4 + SelectB2ProtocolReqType (Daten).DLPD.Size;
      SELECT_B3_PROTOCOL : msgsize := 4 + SelectB3ProtocolReqType (Daten).NCPD.Size;
      RESET_B3           : msgsize := 2;
      GET_PARAMS         : msgsize := 2;
      GET_B3_PARAMS      : msgsize := 2;
    end;

    with msg.Header do begin
      Size       := msgsize + SizeOf (CapiHeader);
      AppID      := ApplicationID;
      Command    := CommandID;
      SubCommand := REQ;
      MsgNumber  := OutMsgID;
    end;

    Move(Daten,msg.Daten,msgsize);

    err := API_PUT_MESSAGE (ApplicationID,@msg);
  end;

  if (err = 0) then
    SendRequestMessage := true
  else begin
    SendRequestMessage := false;
    SetError (CommandID, REQ, err);
  end;

  Inc (OutMsgID);
end;

function TCapiBase.SendResponsMessage (CommandID, MsgID : Word; var Daten) : Boolean;
var
  msg     : CapiMessage;
  err,
  msgsize : Word;
begin
  if not (ApplicationRegistered) then
    err := 4
  else begin
    SendResponsMessage := true;

    msgsize := 0;
    case CommandID of
      CONNECT            : msgsize := 3;
      CONNECT_ACTIVE     : msgsize := 2;
      DISCONNECT         : msgsize := 2;
      INFO               : msgsize := 2;
      CONNECT_B3         : msgsize := 4 + Length (ConnectB3RespType (Daten).NCPI);
      CONNECT_B3_ACTIVE  : msgsize := 2;
      DISCONNECT_B3      : msgsize := 2;
      DATA               : msgsize := 2;
      DATA_B3            : msgsize := 3;
      RESET_B3           : msgsize := 2;
    end;

    with msg.Header do begin
      Size       := msgsize + SizeOf (CapiHeader);
      AppID      := ApplicationID;
      Command    := CommandID;
      SubCommand := RESP;
      MsgNumber  := MsgID;
    end;

    Move(Daten,msg.Daten,msgsize);

    err := API_PUT_MESSAGE (ApplicationID,@msg);
  end;

  if (err = 0) then
    SendResponsMessage := true
  else begin
    SendResponsMessage := false;
    SetError (CommandID, CONF, err);
  end;
end;

function TCapiBase.GetMessage (var CommandID, SubCommand, MsgID : Word; var Daten : IndicationDatenType) : Word;
var
  err : Word;
  msg : ^CapiMessage;
begin
  if not (ApplicationRegistered) then begin
    err := 4;
    SetError (0,0,err);
  end else begin
    err := API_GET_MESSAGE (ApplicationID,msg);

    if (err = 0) then begin
      CommandID  := msg^.Header.Command;
      SubCommand := msg^.Header.SubCommand;
      MsgID      := msg^.Header.MsgNumber;

      Move (msg^.Daten,Daten,msg^.Header.Size);
    end;
  end;

  GetMessage := err;
end;

function TCapiBase.GetAddressMode : TAddressMode;
begin
  if (API_INSTALLED = 0) then begin
    SetError (0,0,2);
    GetAddressMode := Protect;
  end else begin
    if (API_GET_ADDRESSMODE = 1) then
      GetAddressMode := Protect
     else GetAddressMode := Real;
  end;
end;

function TCapiBase.GetVersion  : String;
var versionstr : Array [0..128] of Char;
begin
  if (API_INSTALLED = 0) then begin
    SetError (0,0,2);
    versionstr [0] := #0;
  end else begin
    API_GET_VERSION (@versionstr)
  end;

  GetVersion := StrPas (versionstr);
end;

function TCapiBase.GetSerialNumber : String;
var versionstr : Array [0..128] of Char;
begin
  if (API_INSTALLED = 0) then begin
    SetError (0,0,2);
    versionstr [0] := #0;
  end else begin
    API_GET_SERIAL_NUMBER (@versionstr)
  end;

  GetSerialNumber := StrPas (versionstr);
end;

function TCapiBase.GetHersteller  : String;
var
  versionstr : Array [0..128] of Char;
begin
  if (API_INSTALLED = 0) then begin
    SetError (0,0,2);
    versionstr [0] := #0;
  end else begin
    API_GET_MANUFACTURER (@versionstr)
  end;

  GetHersteller := StrPas (versionstr);
end;

function TCapiBase.GetCommandStr (const Command, SubCommand : Word):string;
var temp:string;
begin (* capi_command *)
  case Command of
    $01:temp:='RESET_B3';
    $02:temp:='CONNECT';
    $09:temp:='CONNECT_INFO';
    $03:temp:='CONNECT_ACTIVE';
    $04:temp:='DISCONNECT';
    $05:temp:='LISTEN';
    $06:temp:='GET_PARAMS';
    $07:temp:='INFO';
    $08:temp:='DATA';
    $40:temp:='SELECT_B2_PROTOCOL';
    $80:temp:='SELECT_B3_PROTOCOL';
    $81:temp:='LISTEN_B3';
    $82:temp:='CONNECT_B3';
    $83:temp:='CONNECT_B3_ACTIVE';
    $84:temp:='DISCONNECT_B3';
    $85:temp:='GET_B3_PARAMS';
    $86:temp:='DATA_B3';
    $87:temp:='HANDSET';
    $FF:temp:='MANUFACTURER'
  else
    temp:='COMMAND_' + IntToHex (Command,2)
  end;

  case SubCommand of
    $00:temp:=temp + '_REQ';
    $01:temp:=temp + '_CONF';
    $02:temp:=temp + '_IND';
    $03:temp:=temp + '_RESP'
  else
    temp:=temp + '_SUBCOMMAND_0x' + IntToHex (SubCommand,2)
  end;

  GetCommandStr:=temp
end;

function TCapiBase.GetErrorStr (const Error : word):string;
var errstr:string;
begin (* capi_error *)
  case error of
    $0000 : errstr := 'Kein Fehler';
    $0001 : errstr := 'CAPI.DLL nicht vorhanden';
    $0002 : errstr := 'CAPI-Treiber nicht installiert';
    $0003 : errstr := 'CAPI-Treiber nicht fr Protected Mode geeignet';
    $0004 : errstr := 'Applikation ist nicht angemeldet';
    $1001 : errstr := 'Fehler beim Registrieren';
    $1002 : errstr := 'Applikationsnummer falsch';
    $1003 : errstr := 'Message zu klein oder Messagenummer falsch kodiert';
    $1004 : errstr := 'Falsches Command oder Subcommand';
    $1005 : errstr := 'Message-Queue voll';
    $1006 : errstr := 'Message-Queue war leer';
    $1007 : errstr := 'Mindestens eine Message an die Applikation ist verlorengegangen, da die Message-Queue voll war';
    $1008 : errstr := 'Fehler bei Deinstallation';
    $2001 : errstr := 'Falscher Controller';
    $2002 : errstr := 'Falscher PLCI';
    $2003 : errstr := 'Falscher NCCI';
    $3101 : errstr := 'B-Channel falsch kodiert';
    $3102 : errstr := 'Info-Mask falsch kodiert';
    $3103 : errstr := 'Serviced-EAZ-Mask falsch kodiert';
    $3104 : errstr := 'Serviced-SI-Mask falsch kodiert';
    $3105 : errstr := 'B2-Protocol falsch';
    $3106 : errstr := 'DLPD falsch';
    $3107 : errstr := 'B3-Protocol falsch';
    $3108 : errstr := 'NCPD falsch';
    $3109 : errstr := 'NCPI falsch';
    $310A : errstr := 'Flags falsch kodiert';
    $3202 : errstr := 'Konflikt zwischen Anmeldungen';
    $3203 : errstr := 'Funktion wird nicht untersttzt';
    $3204 : errstr := 'PLCI nicht aktiv';
    $3205 : errstr := 'NCCI nicht aktiv';
    $3206 : errstr := 'B2-Protokoll wird nicht untersttzt';
    $3207 : errstr := 'Umschalten des B2-Protokolls in diesem Zustand nicht mglich';
    $3208 : errstr := 'B3-Protokoll wird nicht untersttzt';
    $3209 : errstr := 'Umschalten des B3-Protokolls in diesem Zustand nicht mglich';
    $320A : errstr := 'Verwendete Parameter im DLPD werden nicht untersttzt';
    $320B : errstr := 'Verwendete Parameter im NCPD werden nicht untersttzt';
    $320C : errstr := 'Verwendete Parameter im MCPI werden nicht untersttzt';
    $320D : errstr := 'Nicht untersttzte Data-Length';
    $3301 : errstr := 'Fehler beim Aufbau D-Kanal Ebene 1';
    $3302 : errstr := 'Fehler beim Aufbau D-Kanal Ebene 2';
    $3303 : errstr := 'Fehler beim Aufbau B-Kanal Ebene 1';
    $3304 : errstr := 'Fehler beim Aufbau B-Kanal Ebene 2';
    $3305 : errstr := 'Abbruch D-Kanal Ebene 1';
    $3306 : errstr := 'Abbruch D-Kanal Ebene 2';
    $3307 : errstr := 'Abbruch D-Kanal Ebene 3';
    $3308 : errstr := 'Abbruch B-Kanal Ebene 1';
    $3309 : errstr := 'Abbruch B-Kanal Ebene 2';
    $330A : errstr := 'Abbruch B-Kanal Ebene 3';
    $330C : errstr := 'Reestablish B-Kanal Ebene 3';
    $3400
      ..
    $34FF : errstr := 'Abbruch durch das Netzwerk, Cause 0x'+IntToHex (Lo (error),2);
    $4101 : errstr := 'V110 : Verlust der Frame-Synchronisation';
  else
    errstr := 'Fehler 0x'+ IntToHex (error,4);
  end;
  GetErrorStr := errstr;
end;

procedure Register;
begin
  RegisterComponents('Device', [TCapiBase]);
end;

begin
  ClassLoaded   := False;
  CapiLibHandle := 0;
end.
