(****************************************************************************
*                                                                           *
*  Copyright 1996 bei Stefan Graf (CompuServe: 100736.2464)                 *
*                                                                           *
*****************************************************************************)
unit Main;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, StdCtrls, ExtCtrls,
  CapiHand,CapiBase;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Exit1: TMenuItem;
    Info1: TMenuItem;
    Test1: TMenuItem;
    Memo2: TMemo;
    Call1: TMenuItem;
    Disconnect1: TMenuItem;
    Send1: TMenuItem;
    Ein1: TMenuItem;
    Aus1: TMenuItem;
    testtxt1: TMenuItem;
    Select1: TMenuItem;
    OpenFileDialog: TOpenDialog;
    Analog1: TMenuItem;
    Digital1: TMenuItem;
    procedure Info1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Word);
    procedure Capi1Info(Sender: TObject; const Info: Word; var InfoDaten: CapiParameterType);
    procedure Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Word; var Daten: IndicationDatenType);
    function  Capi1DataConnect(Sender: TObject): Boolean;
    procedure Capi1Receive(Sender: TObject; const Count: Word);
    procedure N72465011Click(Sender: TObject);
    procedure N72465021Click(Sender: TObject);
    procedure N72465001Click(Sender: TObject);
    procedure Disconnect1Click(Sender: TObject);
    function Capi1Ring(Sender: TObject;
      const Service: TCapiService;
      const ServiceAdd : Word;
      const CallFrom: TCallNumber;
      const CallTo: TCallNumber): Word;
    procedure FormCreate(Sender: TObject);
    procedure Ein1Click(Sender: TObject);
    procedure Aus1Click(Sender: TObject);
    procedure testtxt1Click(Sender: TObject);
    procedure Select1Click(Sender: TObject);
    procedure Capi1Disconnect(Sender: TObject; const Grund: Word);
    procedure Analog1Click(Sender: TObject);
    procedure Digital1Click(Sender: TObject);
  private
  {$IFDEF Debug}
    LogFile : TextFile;
  {$ENDIF}

    recvflag : Boolean;
    recvfile : File;

    { Private-Deklarationen }
  public
  {$IFDEF CAPI11}
    Capi1 : TCapiHandler;
  {$ENDIF}

  {$IFDEF CAPI20}
    Capi1 : TCapi20Handler;
  {$ENDIF}
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Info1Click(Sender: TObject);
begin
  Memo1.Lines.Add (Capi1.GetVersion);
  Memo1.Lines.Add (Capi1.GetSerialNumber);
  Memo1.Lines.Add (Capi1.GetHersteller);
end;

procedure TForm1.Exit1Click(Sender: TObject);
var daten : ListenReqType;
begin
{$IFDEF CAPI11}
  Capi1.EnableListen ([EAZ_2],[]);
{$ELSE}
  Capi1.EnableListen ([]);
{$ENDIF}

  Close;
end;

procedure TForm1.Capi1MessageDump (Sender: TObject; const CommandID, SubCommand : Word; var Daten: IndicationDatenType);
var
  i    : Word;
  line : String;
begin
  line := Capi1.GetCommandStr (CommandID,SubCommand);

  {$IFDEF CAPI11}
    if (SubCommand = CONF) then begin
      case CommandID of
        DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Conf.BlockNr);
      end;
    end else begin
      case CommandID of
        DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Ind.BlockNr) + ' Size: '
                          + IntToStr (Daten.DataB3Ind.DataSize);
        DISCONNECT_B3 : line := line + ' 0x' + IntToHex (Daten.DisconnectB3Ind.Grund,4);
        DISCONNECT    : line := line + ' 0x' + IntToHex (Daten.DisconnectInd.Grund,4);

        INFO : begin
          line := 'Info (' + IntToStr (Daten.InfoInd.InfoNr) + ') ';
          case Daten.InfoInd.InfoNr of
            $602 : begin
              line := line + 'Gebhren (' + IntToStr (Ord (Daten.InfoInd.Info [2])) + ')';
              line := line + Copy (Daten.InfoInd.Info,3,Length (Daten.InfoInd.Info) - 2);
            end;
            $603 :  line := line + 'Datum ' + Copy (Daten.InfoInd.Info,2,Length (Daten.InfoInd.Info) - 1);
             $28 :  line := line + 'Display';
             $7E :  line := line + 'UserToUser :' + Daten.InfoInd.Info;
              $8 :  line := line + 'Cause 0x' + IntToHex (Ord (Daten.InfoInd.Info [0]),2);
            $607 :  line := line + 'Status 0x' + IntToHex (Ord (Daten.InfoInd.Info [0]),2);
            else  line := line + Daten.InfoInd.Info;
          end;
        end;

        CONNECT : begin
          line := 'Call from ' + Copy (Daten.ConnectInd.CallerAdr,2,255);
          line := line + ' 0x' + IntToHex (Daten.ConnectInd.ReqService,2);
          line := line + ' 0x' + IntToHex (Daten.ConnectInd.ReqServiceAdd,2);
          line := line + ' to ' + Chr (Daten.ConnectInd.ReqEAZ);
        end;
      end;
    end;
  {$ELSE}
    if (SubCommand = CONF) then begin
      case CommandID of
        DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Conf.BlockNr);
      end;
    end else begin
      case CommandID of
        DATA_B3 : line := line + ' Block: ' + IntToStr (Daten.DataB3Ind.BlockNr) + ' Size: '
                          + IntToStr (Daten.DataB3Ind.DataSize);
        DISCONNECT    : line := line + ' 0x' + IntToHex (Daten.DisconnectInd.Reason,4);

        INFO : begin
          line := 'Info (' + IntToHex (Daten.InfoInd.InfoNr,4) + ') ';
          if ((Daten.InfoInd.InfoNr and $8000) = 0) then begin
            for i := 1 to Length (Daten.InfoInd.Info) do
              line := line + ' ' + IntToHex (Ord (Daten.InfoInd.Info [i]),2);
          end;
        end;

        CONNECT : begin
          line := 'Call from ' + Copy (Daten.ConnectInd.CalledNumber,2,255);
        end;
      end;
    end;
  {$ENDIF}

  line := Copy (line,1,60);
  Memo1.Lines.Add (line);
end;

procedure TForm1.Capi1Error(Sender: TObject; const CommandID, SubCommand, ErrorNumber: Word);
begin
  MessageDLG (Capi1.GetCommandStr (CommandID,SubCommand) + ' : ' + Capi1.GetErrorStr (ErrorNumber), mtWarning, [mbOK], 0);
end;

function TForm1.Capi1Ring(Sender: TObject;
                          const Service : TCapiService;
                          const ServiceAdd : Word;
                          const CallFrom: TCallNumber;
                          const CallTo: TCallNumber) : Word;
  const
    ServiceStr : array [0..15] of String [15] = ('TELEPHONY','AB_SERVICE','X21',
                                                 'FAX4','BTX','UNKNOWN','DATA_64K','X25',
                                                 'TTX64','MIXED_MODE','UNKNOWN','TEMEX',
                                                 'REMUTE','GRAPHIC_TELEPHONY',
                                                 'NEW_BTX','VIDEO_TELEPHONY');
  var
    line : String;
begin
  line := 'Call from ' + Copy (CallFrom,3,255) + ' to ' + Copy (CallTo,2,255);
  line := line + ' for ' + IntToStr (Ord (Service));

  line := Copy (line,1,40);
  Memo2.Lines.Add (line);

  if (Service = DATA_64K) then
    Capi1Ring := 0
  else Capi1Ring := 1;
end;

procedure TForm1.Capi1Info(Sender: TObject; const Info: Word;
  var InfoDaten: CapiParameterType);
var line : String;
begin
  line := 'Info (' + IntToHex (Info,4) + ') ';
  if ((Info and $8000) = 0) then begin
    case (Info and $00FF) of
     $40 : begin
             line := line + 'Gebhren ';
           end;
     $29 : begin
             line := line + 'Datum : ' + IntToStr (Ord (InfoDaten [3])) + '.';
             line := line + IntToStr (Ord (InfoDaten [2])) + '.';
             line := line + '19' + IntToStr (Ord (InfoDaten [1]));
             line := line + ' ' + IntToStr (Ord (InfoDaten [4]));
             line := line + ':' + IntToStr (Ord (InfoDaten [5]));
           end;
    end;
  end else begin
  end;

  line := Copy (line,1,60);
  Memo2.Lines.Add (line);
end;

function TForm1.Capi1DataConnect(Sender: TObject): Boolean;
begin
{$IFDEF DEBUG}
  AssignFile (LogFile,'CAPI.LOG');
  Rewrite (LogFile);
{$ENDIF}

  recvflag := False;

  Capi1DataConnect := True;
end;

procedure TForm1.Capi1Receive(Sender: TObject; const Count: Word);
var
  i,
  size,
  writeanz : Word;
  ch       : Char;
  line     : String;
  fname    : TFileName;
  buf      : Array [0..2048] of Char;

begin
  Memo2.Lines.Add ('Received ' + IntToStr (Count) + ' Bytes');

  Capi1.Read (buf,Count);

{$IFDEF Debug}
  Write (LogFile,Count,' : ');
  if (IOResult <> 0) then;
  if (Count > 40) then
    size := 40
  else size := Count;
  for i:=0 To (size - 1) do begin
    Write (LogFile,IntToHex (Ord (buf [i]),2),' ');
    if (IOResult <> 0) then;
  end;
  WriteLn (LogFile);
  if (IOResult <> 0) then;
  Flush (LogFile);
{$ENDIF}

  if (recvflag) then begin
    if (buf [0] = #255) and (buf [1] = #255) then begin
       CloseFile (recvfile);
       recvflag := false;
       line := 'Close File';
    end else begin
      writeanz := Count - 2;
      line := 'Write ' + IntToStr (writeanz) + ' Bytes : ';
      BlockWrite (recvfile,buf [2],writeanz);

      if (IOResult = 0) then
        line := line + ' Ok'
      else line := line + ' Fehler';
      line := 'Write ' + IntToStr (Count) + ' Bytes : ';
    end;

    Memo2.Lines.Add (line);
  end else begin
    i:=0;

    repeat
      if (buf [i] = #255) then begin
        Inc (i);

        if (buf [i] = #255) then begin
          Inc (i);

          Move (buf [i], fname, Ord (buf [i]) + 1);
          Inc (i,Ord (buf [i]) + 1);

          AssignFile (recvfile,fname);
          Rewrite (recvfile,1);
          if (IOResult = 0) then begin
            recvflag := true;
            i := Count + 1;
          end;
        end;
      end;

      if not (recvflag) then
        SendMessage (Memo2.Handle,WM_CHAR,Word (buf [i]),0)
      else Memo2.Lines.Add ('Receive file ' + Copy (fname,1,12));

      Inc (i);
    until (i >= (Count - 1));
  end;
end;

procedure TForm1.N72465011Click(Sender: TObject);
begin
  Capi1.Call ('02317246501',DATA_64k);
end;

procedure TForm1.N72465021Click(Sender: TObject);
begin
  Capi1.Call ('02317246502',DATA_64k);
end;

procedure TForm1.N72465001Click(Sender: TObject);
begin
  {$IFDEF CAPI11}
    Capi1.Call ('02317246500',TELEPHONY);
  {$ELSE}
    Capi1.Call ('02317246500',ANALOG_TELEPHONY);
  {$ENDIF}
end;

procedure TForm1.Disconnect1Click(Sender: TObject);
begin
  Capi1.DisconnectLine (1);
end;

procedure TForm1.testtxt1Click(Sender: TObject);
var
  line    : String;
  filevar : TextFile;
begin
  AssignFile (filevar,'C:\autoexec.bat');

  Reset (filevar);

  while Not (Eof (filevar)) Do begin
    ReadLn (filevar,line);
    line := line + #13 + #10;

    Capi1.Write (line [1],Length (line));
  end;

  CloseFile (filevar);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
{$IFDEF CAPI11}
  Capi1 := TCapiHandler.Create (Self);

  Capi1.OwnEAZ := EAZ_1;
  Capi1.Infos := [Gebuehren,DatumZeit,Display,UserToUser,DisconnectCause,Status];

  Capi1.OnError         := Capi1Error;
  Capi1.MessageDump     := Capi1MessageDump;
  Capi1.OnRing          := Capi1Ring;
  Capi1.OnDataConnect   := Capi1DataConnect;
  Capi1.OnReceive       := Capi1Receive;
  Capi1.OnInfo          := Capi1Info;
  Capi1.OnDisconnect    := Capi1Disconnect;
{$ELSE}
  Capi1 := TCapi20Handler.Create (Self);

  Capi1.Controller := 1;
  Capi1.OwnNumber  := '7246501';
  Capi1.Infos      := [Gebuehren,DatumZeit,Display,UserToUser,DisconnectCause,CalledNumber];

  Capi1.OnError         := Capi1Error;
  Capi1.MessageDump     := Capi1MessageDump;
  Capi1.OnRing          := Capi1Ring;
  Capi1.OnDataConnect   := Capi1DataConnect;
  Capi1.OnReceive       := Capi1Receive;
  Capi1.OnInfo          := Capi1Info;
  Capi1.OnDisconnect    := Capi1Disconnect;

{
  Capi1.OnDisconnect    :=;
  Capi1.OnSend          :=;
  Capi1.OnConnect       :=;
  Capi1.OnDataInfo      :=;
  Capi1.OnMessage       :=;
}
{$ENDIF}
end;

procedure TForm1.Ein1Click(Sender: TObject);
begin
  {$IFDEF CAPI11}
    Capi1.EnableListen ([EAZ_2],[TELEPHONY, DATA_64k]);
  {$ELSE}
    Capi1.EnableListen ([ANALOG_TELEPHONY, DATA_64k]);
  {$ENDIF}
end;

procedure TForm1.Aus1Click(Sender: TObject);
begin
  {$IFDEF CAPI11}
    Capi1.EnableListen ([],[]);
  {$ELSE}
    Capi1.EnableListen ([]);
  {$ENDIF}
end;

procedure TForm1.Select1Click(Sender: TObject);
type
  bufarray = array [1..8196] of char;
var
  filevar : File;
  fname   : TFileName;
  line    : String;
  time    : LongInt;
  i,
  anz,
  err,
  strpos,
  sendanz : Word;
  maxread,
  readanz : Cardinal;
  size    : LongInt;
  buf     : ^bufarray;
begin
  OpenFileDialog.FileName := '*.*';

  if OpenFileDialog.Execute then Begin
    AssignFile (filevar,OpenFileDialog.FileName);

    Reset (filevar,1);
    if (IOResult <> 0) Then
      MessageDLG ('Datei ' + OpenFileDialog.FileName + ' kann nicht geffnet werden', mtWarning, [mbOK], 0)
    else begin
      size:=FileSize (filevar);

      fname := OpenFileDialog.FileName;

      repeat
        strpos := Pos ('\',fname);
        if (strpos > 0) then
          Delete (fname,1,strpos);
      until (strpos = 0);

      line:=#255 + #0 + Chr (Length (fname)) + fname;
      Capi1.Write (line [1],Length (line));

      GetMem (buf,8196);

      time := GetTickCount;

      err := 0;

      while not eof (filevar) and (err = 0) do begin
        {$IFDEF CAPI11}
          maxread := Capi1.BufferSize - 2;
        {$ELSE}
          maxread := Capi1.BDataBlockSize - 2;
        {$ENDIF}

        BlockRead (filevar,buf^[3],maxread,readanz);

        if (IOResult <> 0) then begin
          err := 1;
          MessageDLG ('Lesefehler in ' + OpenFileDialog.FileName, mtWarning, [mbOK], 0)
        end else begin
          Memo1.Lines.Add ('Send ' + IntToStr (readanz) + ' Bytes');

          if (readanz > 0) then begin
            buf^[1] := #255;
            buf^[2] := #3;

            if (Capi1.Write (buf^,readanz + 2) <> (readanz + 2)) then
              err := 2;
          end;
        end;
      end;

      time := GetTickCount - time;
      line := IntToStr (time) + ' ms / ';
      if (time <> 0) then
        line := line + IntToStr (1000 * size Div time)
      else line := line + '---';
      line:= line + ' Bytes/Sec';

      Memo2.Lines.Add (line);

      FreeMem (buf,8196);

      line:=#255 + #1;
      Capi1.Write (line [1],Length (line));

      CloseFile (filevar);
    end;
  end;
end;

procedure TForm1.Capi1Disconnect(Sender: TObject; const Grund: Word);
begin
  if (recvflag) then
    CloseFile (recvfile);

  recvflag := false;

{$IFDEF Denug}
  CloseFile (LogFile);
{$ENDIF}
end;

procedure TForm1.Analog1Click(Sender: TObject);
var numstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    Capi1.Call (numstr,TELEPHONY);
  end;
end;

procedure TForm1.Digital1Click(Sender: TObject);
var numstr : String [20];
begin
  numstr := InputBox ('Telefonnummer','Rufnummer eingeben','');
  if (Length (numstr) > 0) then begin
    Capi1.Call (numstr,DATA_64K);
  end;
end;

end.
