(****************************************************************************
*                                                                           *
*  Copyright 1996 bei Stefan Graf (CompuServe: 100736.2464)                 *
*                                                                           *
*****************************************************************************)
unit Rufmain;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Capibase, Capihand, StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Capi1: TCapiHandler;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    function Capi1Ring(Sender: TObject; const Service: TCapiService;
      const ServiceAdd: Word; const CallFrom, CallTo: TCallNumber): Word;
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  {$IFDEF CAPI_2}
    Capi1.EnableListen ([ALL]);
  {$ELSE}
    Capi1.EnableListen ([EAZ_1,EAZ_2,EAZ_3],[TELEPHONY,AB_SERVICE,FAX4,DATA_64K]);
  {$ENDIF}
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {$IFDEF CAPI_2}
    Capi1.EnableListen ([]);
  {$ELSE}
    Capi1.EnableListen ([],[]);
  {$ENDIF}
end;

function TForm1.Capi1Ring(Sender: TObject; const Service: TCapiService;
  const ServiceAdd: Word; const CallFrom, CallTo: TCallNumber): Word;
var
  datafile : TextFile;
  line1,line2 : String [128];
  nowtime : TDateTime;
begin
  nowtime := Now;
  line1 := DateToStr (nowtime) + ' ' + TimeToStr (nowtime);

  {$IFDEF CAPI_2}
  line2 := 'Call from ' + Copy (CallFrom,3,Length (CallFrom) - 2);
  line2 := line2 + ' to ' + Copy (CallTo,2,Length (CallTo) - 1) + ' : ' + IntToStr (ServiceAdd) + '=';
  {$ELSE}
  line2 := 'Call from ' + Copy (CallFrom,3,Length (CallFrom) - 2);
  line2 := line2 + ' to EAZ ' + CallTo + ' : ' + IntToStr (ServiceAdd) + '=';
  {$ENDIF}

  {$IFDEF CAPI_2}
    if (Service = ANALOG_TELEPHONY) then
      line2 := line2 + 'analog'
    else if (Service = DIGITAL_TELEPHONY) then
      line2 := line2 + 'digital'
    else if (Service = FAX3) then
      line2 := line2 + 'fax G3'
    else if (Service = FAX4) then
      line2 := line2 + 'fax G4'
    else if (Service = DATA_64K) then
      line2 := line2 + 'data 64 kBit'
    else line2 := line2 + '???';
  {$ELSE}
    if (Service = TELEPHONY) then
      line2 := line2 + 'analog'
    else if (Service = AB_SERVICE) then
      line2 := line2 + 'ab'
    else if (Service = FAX4) then
      line2 := line2 + 'fax G4'
    else if (Service = DATA_64K) then
      line2 := line2 + 'data 64 kBit'
    else line2 := line2 + '???';
  {$ENDIF}

  Memo1.Lines.Add (line1);
  Memo1.Lines.Add (line2);

  AssignFile (datafile,'ANRUFE.DAT');
  Append (datafile);
  if (IOResult <> 0) then
    Rewrite (datafile);

  if (IOResult = 0) then begin
    WriteLn (datafile,line1,' : ',line2);

    CloseFile (datafile);
  end;

  {$IFDEF CAPI_2}
    Capi1Ring := IGNORE_CALL;
  {$ELSE}
    Capi1Ring := 0;
  {$ENDIF}
end;

end.
